/*
 * Created on 7 juin 2006
 * 
 */
package gus05.entity.gus.file.action.load.dir;

import java.io.File;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.framework.resources.ActionBuilder;
import gus05.framework.resources.FileProvider;


public class LoadDirAction implements Entity, Transform {

    
    public String getName()				{return "gus.file.action.load.dir";}
    public String getCreationDate()		{return "2006.06.07";}

    public static final String ACTION_ID = "FILEACTION_load";

    private ActionBuilder builder;
    private FileProvider fileProvider;    
    
    
    public LoadDirAction() throws Exception
    {
        builder = (ActionBuilder)Outside.resource(this,"app.actionbuilder");
        fileProvider = (FileProvider)Outside.resource(this,"gus.file.action.choose.dir");
    }
    
    public Object transform(Object arg0) throws Exception
    {
        Give give = (Give)arg0;
        return builder.build(ACTION_ID,new ExecuteLoad(give));
    }
    
    private class ExecuteLoad implements Execute
    {
        private Give give;
        ExecuteLoad(Give give) {this.give = give;}
        public void execute() throws Exception
        {provideFile(give);}
    }
    
    private void provideFile(Give give) throws Exception
    {
        File file = fileProvider.getFile("load");
        give.give(file);
    }
}
