package gus05.entity.gus.file.explorer.control.rootcontrol1;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JComponent;
import javax.swing.JTree;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;



public class RootControl1 extends DefaultSupport implements Entity, Graphic, Give, Provide, Register, KeyListener {


    public String getName()				{return "gus.file.explorer.control.rootcontrol1";}
    public String getCreationDate()		{return "2006.09.10";}



    private Service dirLabel;
    private Give rootReceiver;
    private JTree tree;
    
    
    public RootControl1() throws Exception
    {dirLabel = Outside.service(this,"gus.file.label.load.filedirlabel2");}

    
    public void give(Object obj) throws Exception
    {dirLabel.give(obj);}
    
    public Object provide() throws Exception
    {return dirLabel.provide();}
    
    public JComponent gui()
    {return dirLabel.gui();}
    
    
    
    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("rootReceiver"))
        {rootReceiver = (Give)obj;return;}
        
        if(key.equals("tree"))
        {init((JTree)obj);return;}
        
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    
    private void init(JTree tree)
    {
        this.tree = tree;
        tree.addKeyListener(this);
        tree.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e)
            {moveRoot();}
        });
        
        dirLabel.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {newRoot();}});
    }
    
    
    
    
    private void moveRoot()
    {
        try
        {
            rootReceiver.give(null);
            send(this,"moveRoot()");
        }
        catch(Exception e)
        {Outside.err(this,"moveRoot()",e);}
    }
    
    
    
    
    private void newRoot()
    {
        try
        {
            rootReceiver.give(dirLabel.provide());
            send(this,"newRoot()");
        }
        catch(Exception e)
        {Outside.err(this,"newRoot()",e);}
    }
    
    
    
    
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {released(e.getKeyCode());}
    
    
    private void released(int keyCode)
    {
        if(keyCode==KeyEvent.VK_SPACE)
            moveRoot();
    }
}

