package gus05.entity.gus.file.explorer.mapext.explorer1.maingui1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;



public class MapExtMainGui1 implements Entity, Graphic {


    public String getName()				{return "gus.file.explorer.mapext.explorer1.maingui1";}
    public String getCreationDate()		{return "2008.12.14";}


    
    private Service explorer;
    private Service rootChooser;
    private Service analyzer;
    
    private JPanel panel;
    private JLabel labelTitle;
    private File root;

    private boolean analyzing = false;
    


    public MapExtMainGui1() throws Exception
    {
    	explorer = Outside.service(this,"gus.file.explorer.mapext.explorer1");
    	rootChooser = Outside.service(this,"gus.file.dirscan.gui.rootdirchooser");
    	analyzer = Outside.service(this,"gus.file.dirscan.info.analyzer");
        
    	rootChooser.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{if(!analyzing) start();}
		});
    	analyzer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{complete();}
		});
    	
    	
        panel = new JPanel(new BorderLayout());
        panel.add(buildPanel_top(),BorderLayout.NORTH);
        panel.add(buildPanel_center(),BorderLayout.CENTER);
    }



    public JComponent gui()
    {return panel;}
    
    
    
    
    
    private JPanel buildPanel_top()
    {
    	JPanel p = new JPanel(new BorderLayout());
    	labelTitle = label("SCANNER");
    	p.add(labelTitle,BorderLayout.NORTH);
    	p.add(rootChooser.gui(),BorderLayout.CENTER);
    	p.setBorder(border());
    	return p;
    }
    
    
    
    
    private JPanel buildPanel_center()
    {
    	JPanel p = new JPanel(new BorderLayout());
    	p.add(label("RESULTS"),BorderLayout.NORTH);
    	p.add(explorer.gui(),BorderLayout.CENTER);
    	p.setBorder(border());
    	return p;
    }
    
	
    
    
    
    private JLabel label(String title)
    {
    	JLabel label = new JLabel(title);
    	label.setHorizontalAlignment(JLabel.CENTER);
    	label.setOpaque(true);
    	label.setBackground(Color.BLUE.darker());
    	label.setForeground(Color.WHITE);
    	return label;
    }
    
    
    private Border border()
    {
    	Border b1 = BorderFactory.createBevelBorder(BevelBorder.RAISED);
    	Border b2 = BorderFactory.createEmptyBorder(3,3,3,3);
    	return BorderFactory.createCompoundBorder(b2,b1);
    }
    


	
	
	
	private void start()
	{
		try
		{
			root = (File) rootChooser.provide();
			if(root==null) return;
			
			analyzing = true;
			labelTitle.setText("SCANNER - Currently scanning. Please wait...");
			analyzer.give(root);
			new Thread(analyzer).start();
		}
		catch(Exception e)
		{Outside.err(this,"start()",e);}
	}
	
	
	
	
	
	private void complete()
	{
		try
		{
			labelTitle.setText("SCANNER");
			explorer.give(root);
			analyzing = false;
		}
		catch(Exception e)
		{Outside.err(this,"complete()",e);}
	}
}

