/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.file.explorer.tree2;

/**
 *
 * @author  gus
 */
import java.io.*;

import gus05.framework.tools.Send;



class ExplorerJTree extends AbstractJTree {
    
    
    private Send d;
    private ExplorerTreeModel model;
    
    public ExplorerJTree(Send d)
    {
        super();
        setModel(null);
        this.d = d;
    }
    
  
    public void setRoot(File root)
    {
        model = new ExplorerTreeModel(root);
        setModel(model);
    }
    
    public File getRoot()
    {return (File) model.getRoot();}
    
    

    public File getSelectedFile()
    {return (File)getLastSelectedPathComponent();}
    

    protected void selectFromJTree()
    {d.send(this,"selectFromJTree()");}
    
    
    public void moveRoot()
    {
        File file = getSelectedFile();
        if(file==null)return;
        
        if(getSelectionPath().getPathCount()==1)
        {
            File parent = file.getParentFile();
            if(parent!=null)setRoot(parent);
        }
        else setRoot(file);
    }
}
