package gus05.entity.gus.file.label.chooseroot;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;

import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.filechooser.FileSystemView;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.framework.resources.IconProvider;



public class LabelChooseRoot implements Entity, Transform {


    public String getName()				{return "gus.file.label.chooseroot";}
    public String getCreationDate()		{return "2007.08.05";}

    
    private IconProvider iconProvider;
    
    public LabelChooseRoot() throws Exception
    {
        iconProvider = (IconProvider) Outside.resource(this,"app.gui.icons");
    }

  
    
    public Object transform(Object obj) throws Exception
    {
        Give give = (Give)obj;
        return new JLabelRoot(give);
    }
    
    
    
    private void giveFile(Give give, File root)
    {
        try{give.give(root);}
        catch(Exception e)
        {Outside.err(this,"giveFile(Give,File)",e);}
    }
    
    
    
    private Icon icon(File root)
    {return FileSystemView.getFileSystemView().getSystemIcon(root);}
    
    
    
    
    private class JLabelRoot extends JLabel implements MouseListener
    {
        private JPopupMenu popup;
        
        public JLabelRoot(Give give)
        {
            super(iconProvider.getIcon("FILEACTION_chooseRoot"));
            setFocusable(true);
            addMouseListener(this);
            
            popup = new JPopupMenu();
            popup.setBorderPainted(false);
            
            File[] roots = File.listRoots();
            for(int i=0;i<roots.length;i++)
            popup.add(new JMenuItemRoot(give,roots[i]));
        }
        
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mousePressed(MouseEvent e) {showPopup();}
        public void mouseReleased(MouseEvent e) {}
        
        private void showPopup()
        {popup.show(this,0,getHeight());}
    }
    
    
    
    
    
    
    
    
    private class JMenuItemRoot extends JMenuItem implements ActionListener
    {
        private Give give;
        private File root;
        
        public JMenuItemRoot(Give give, File root)
        {
            super(root.getAbsolutePath(),icon(root));
            this.give = give;
            this.root = root;
            addActionListener(this);
        }

        public void actionPerformed(ActionEvent e)
        {giveFile(give,root);}
    }
    
}

