
package gus05.entity.gus.file.label.load.dirpathselector;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.Action;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;


public class DirPathSelector extends DefaultSupport implements Entity, Give, Provide, Graphic, Retrieve {

    public String getName()				{return "gus.file.label.load.dirpathselector";}
    public String getCreationDate()		{return "2007.01.15";}
    
    
    private Service toolbar;
    private Service load;
    
    private JTextField0 textField;
    private File dir;
    private JPanel pane;
    

    
    
    public DirPathSelector() throws Exception
    {
        toolbar = Outside.service(this,"gus.graphic.toolbar.toolbar1");
        load = Outside.service(this,"gus.file.action.load.dir");
        
        textField = new JTextField0();
        
        Action loadAction = (Action)load.transform(new Give(){
            public void give(Object obj) throws Exception
            {selectDir((File)obj);}
        });
        JToolBar toolBar = (JToolBar)toolbar.gui();
        toolBar.add(loadAction);
        
        pane = new JPanel(new BorderLayout());
        pane.add(textField,BorderLayout.CENTER);
        pane.add(toolBar,BorderLayout.EAST);
    }
    
    
    
    
    
    
    
    
    
    public void give(Object obj) throws Exception
    {
        if(obj==null)return;
        
        if(obj instanceof File) handleFile((File)obj);
        else if(obj instanceof String) handleFile((String)obj);
        else handleFile(obj.toString());
    }
    
    private void handleFile(String path) throws Exception
    {handleFile(new File(path));}
    
    private void handleFile(File dir_) throws Exception
    {
        if(dir_.exists() && !dir_.isDirectory())
            throw new Exception("Invalid dir : "+dir_.getAbsolutePath());
        dir = dir_;
        textField.setText(dir.getAbsolutePath());
    }
    

    
    
    
    
    
    
    
    
    
    public Object provide() throws Exception
    {return dir;}
    
    
    public JComponent gui()
    {return pane;}
    
    
    
    
    
    
    
    private void selectDir(String path)
    {selectDir(new File(path));}
    
    
    
    private void selectDir(File dir_)
    {
        if(dir_.exists() && !dir_.isDirectory()) return;
        if(!dir_.exists())
        {
            int v = JOptionPane.showConfirmDialog(null,"Dir "+dir_.getAbsolutePath()+" does not exist. Create ?");
            if(v==JOptionPane.YES_OPTION) dir_.mkdirs();
        }
        dir = dir_;
        textField.setText(dir.getAbsolutePath());
        dirSelected();
    }
    
    
    private void dirSelected()
    {send(this,"dirSelected()");}
    
    
    
    
    
    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("textField")) return textField;
        if(key.equals("keys")) return new String[]{"textField"};
        
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    
    
    
    
    
    
    private class JTextField0 extends JTextField implements ActionListener, DocumentListener
    {
        public JTextField0()
        {
            super();
            addActionListener(this);
            getDocument().addDocumentListener(this);
        }
        
        public void updateGUI()
        {
            if(dir==null || !getText().equals(dir.getAbsolutePath()))
            setForeground(Color.RED);
            else setForeground(Color.BLACK);
        }
        
        public void actionPerformed(ActionEvent e)
        {selectDir(getText());}
        
        
        public void changedUpdate(DocumentEvent e) {}
        public void insertUpdate(DocumentEvent e){updateGUI();}
        public void removeUpdate(DocumentEvent e){updateGUI();}
    }

}
