/*
 * Created on 28 juil. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.entity.gus.graphic.platform.findcomp;

import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.Scrollable;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;
import gus05.framework.features.Transform;


public class FindComp implements Entity, Transform {

    public String getName()				{return "gus.graphic.platform.findcomp";}
    public String getCreationDate()		{return "2006.07.28";}

    
    private Service entityProvider;
    private Service newEntityProvider;
    private Service uniqueEntityProvider;
    
    

    public FindComp() throws Exception
    {
        entityProvider = Outside.service(this,"app.entity");
        newEntityProvider = Outside.service(this,"app.entity.new");
        uniqueEntityProvider = Outside.service(this,"app.entity.unique");
    }
    
    public Object transform(Object obj) throws Exception
    {return findComp(obj);}

    
    
    
    private JComponent findComp(Object obj) throws Exception
    {
        if(obj==null)return null;
        
        if(obj instanceof JComponent)
        {
            JComponent comp = (JComponent)obj;
            return findComp(comp);
        }    
        if(obj instanceof Graphic)
        {
            Graphic g = (Graphic)obj;
            return findComp(g.gui());
        }   
        if(obj instanceof String)
        {
            String entityName = (String)obj;
            return findEntityComp(entityName);
        }
        throw new Exception("Invalid input: "+obj.getClass().getName());
    }
    
    
    
    
    
    private JComponent findComp(JComponent comp) throws Exception
    {
        if(comp instanceof Scrollable)
            return new JScrollPane(comp);
        return comp;
    }
    
    
    
    
    
    
    
    private JComponent findEntityComp(String entityName) throws Exception
    {
        Service provider = entityProvider;
        
        if(entityName.startsWith("*"))
        {
            entityName = entityName.substring(1);
            provider = newEntityProvider;
        }
        else if(entityName.startsWith("+"))
        {
            entityName = entityName.substring(1);
            provider = uniqueEntityProvider;
        }
        Graphic g = (Graphic)provider.transform(entityName);
        return findComp(g.gui());
    }
}
