/*
 * Created on 7 juil. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.entity.gus.graphic.scrollpane.scrollsynchronizer;

import javax.swing.BoundedRangeModel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.framework.features.Register;


public class ScrollSynchronizer implements Entity, Give, Register {

    public String getName()				{return "gus.graphic.scrollpane.scrollsynchronizer";}
    public String getCreationDate()		{return "2006.07.07";}

    
    private boolean vertical = true;
    private boolean horizontal = true;

    
    
    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("vertical"))
        {vertical = Boolean.parseBoolean(obj.toString());return;}
        
        if(key.equals("horizontal"))
        {horizontal = Boolean.parseBoolean(obj.toString());return;}
        
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    
    public void give(Object obj) throws Exception
    {
        JScrollPane[] scrolls = (JScrollPane[])obj;
        if(scrolls.length<2)
            throw new Exception("not enough scroll for synchronizing: "+scrolls.length);
        
        if(vertical)
        {
            JScrollBar[] bars = new JScrollBar[scrolls.length];
            for(int i=0;i<bars.length;i++)
            bars[i] = scrolls[i].getVerticalScrollBar();
            new SynchScroll(bars);
        }
        if(horizontal)
        {
            JScrollBar[] bars = new JScrollBar[scrolls.length];
            for(int i=0;i<bars.length;i++)
            bars[i] = scrolls[i].getHorizontalScrollBar();
            new SynchScroll(bars);
        }
    }
    
    
    
    
    
    
    
    private class SynchScroll implements ChangeListener {

        private BoundedRangeModel[] models;
        
        public SynchScroll(JScrollBar[] bars)
        {
            models = new BoundedRangeModel[bars.length];
            for(int i=0;i<bars.length;i++)
            {
                models[i] = bars[i].getModel();
                models[i].addChangeListener(this);
            }
        }

        public void stateChanged(ChangeEvent e)
        {
            for(int i=0;i<models.length;i++)
            if(models[i].getMaximum()<=0)return;
            
            BoundedRangeModel modelSrc = (BoundedRangeModel)e.getSource();
            int value = modelSrc.getValue();
            
            for(int i=0;i<models.length;i++)
            models[i].setValue(value);
        }
    }

}
