package gus05.entity.gus.graphic.tabbedpane.tab1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.resources.IconProvider;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JTabbedPane;



public class Tab1 implements Entity, Graphic, Register {


    public String getName()				{return "gus.graphic.tabbedpane.tab1";}
    public String getCreationDate()		{return "2006.09.10";}



    private Service findComp;
    private IconProvider iconProvider;
    private JTabbedPane tabbed;
    private String toolTip;
    
    
    private Icon icon(String key)
    {return iconProvider.getIcon(key);}

    public Tab1() throws Exception
    {
        findComp = Outside.service(this,"gus.graphic.platform.findcomp");
        iconProvider = (IconProvider) Outside.resource(this,"app.gui.icons");
        tabbed = new JTabbedPane();
    }



    public JComponent gui()
    {return tabbed;}



    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("toolTip"))
        {toolTip = (String) obj;return;}
        
        String[] n = key.split("#",2);
        JComponent comp = (JComponent)findComp.transform(obj);
        
        String title = n.length==1?n[0]:n[1];
        Icon icon = n.length==1?null:icon(n[0]);
        
        tabbed.addTab(title,icon,comp,toolTip);
    }


}

