package gus05.manager.gus.endorf.layer3.loading;

import gus05.manager.gus.endorf.layer3.system1.System1;
import gus05.manager.gus.endorf.layer3.tools.Tools_debug;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

public class Loader_prop extends Loader {

    
    
    
    public Loader_prop()
    {super("properties");}  
    
    
    protected void insideLoad()
    {
        try
        {
            Properties p = insideProp("properties");
            if(p==null) return;
            registerProperties(p);
            debug("insideLoad()","load "+p.size()+" properties from inside");
        }
        catch(Exception e)
        {System1.handleError(this,"insideLoad()",e);}
    }
    
    
    
    
    
    protected void outsideLoad()
    {
        try
        {
        	if(System1.hasProperty(System1.PATH_PROPERTYFILE))
        	{
        		File f = System1.searchFile(System1.PATH_PROPERTYFILE);
        		System1.propFile=f;
        	}
        	
            File f = outsideFile(System1.propFile,"property file");
            if(f==null) return;
            
            Properties p = new Properties();
            FileInputStream fis = new FileInputStream(f);
            p.load(fis);
            fis.close();
            
            if(System1.initOutside)
                initProperties(p,f);
            
            registerProperties(p);
            
            debug("outsideLoad()","load "+p.size()+" properties from: "+f.getAbsolutePath());
        }
        catch(Exception e)
        {System1.handleError(this,"outsideLoad()",e);}
    }
    
    
    
    private void registerProperties(Properties p)
    {
        System1.properties.putAll(p);
        debug(p);
        increase(p.size());
    }
    
    
    
    private void debug(Properties p)
    {
        if(System1.booleanProperty_false(System1.PROPKEY_DEBUGPROP))
            Tools_debug.displayProp("from Loader_prop",p);
    }
    
    
    
    
    
    
    private void initProperties(Properties p, File f)
    {
        try
        {
            check(p,System1.PATH_LOGDIR,"log");
            check(p,System1.PATH_LINGDIR,"ling");
            check(p,System1.PATH_ICONDIR,"icon");
            check(p,System1.PATH_ENTITYDIR,"entity");
            check(p,System1.PATH_SOUNDDIR,"sound");
            check(p,System1.PATH_WORKSPACE,"workspace");
            check(p,System1.PATH_POOLDIR,"pool");
            check(p,System1.PATH_MAPPINGFILE,System1.appName+"_mapping.properties");
            check(p,System1.PATH_LOADFILE,System1.appName+"_load.properties");
            check(p,System1.PATH_STARTFILE,System1.appName+"_start.txt");
            
            FileOutputStream fos = new FileOutputStream(f);
            p.store(fos,"");
            fos.close();
        }
        catch(Exception e)
        {System1.handleError(this,"initProperties(Properties, File)",e);}
    }
    
    
    
    
    private void check(Properties p, String key, String fileName)
    {if(!p.containsKey(key)) p.setProperty(key,"<path.rootdir>"+File.separator+fileName);}
    
}
