package gus05.manager.gus.endorf.layer4.system2;

import java.awt.event.ActionListener;
import java.io.File;
import java.io.PrintStream;
import java.util.Map;
import java.util.Set;

import gus05.framework.features.Filter;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Support;
import gus05.framework.features.Transform;
import gus05.framework.resources.StringProvider;
import gus05.manager.gus.endorf.layer2.datasupport.SupportMap;
import gus05.manager.gus.endorf.layer2.datasupport.SupportSet;
import gus05.manager.gus.endorf.layer3.loading.Loader_entities;
import gus05.manager.gus.endorf.layer3.system1.System1;



public class System2 extends System1 {

	
	public static final String managerID = "Endorf_20081220";
    
	
	
    
    public static final String RESOURCEPROVIDER_PERSISTENCE     = "persistence";
    public static final String RESOURCEPROVIDER_ICONPROVIDER    = "iconprovider";
    public static final String RESOURCEPROVIDER_ACTIONBUILDER   = "actionbuilder";
    public static final String RESOURCEPROVIDER_COLOR           = "color";
    public static final String RESOURCEPROVIDER_ICON            = "icon";
    public static final String RESOURCEPROVIDER_STRING          = "string";
    public static final String RESOURCEPROVIDER_STRING2         = "string2";
    public static final String RESOURCEPROVIDER_ARG             = "arg";
    public static final String RESOURCEPROVIDER_BOOLEAN         = "boolean";
    public static final String RESOURCEPROVIDER_INTEGER         = "integer";
    public static final String RESOURCEPROVIDER_LONG            = "long";
    public static final String RESOURCEPROVIDER_DOUBLE          = "double";
    public static final String RESOURCEPROVIDER_OBJECT          = "object";
    public static final String RESOURCEPROVIDER_OBJECT2         = "object2";
    public static final String RESOURCEPROVIDER_CLASS           = "class";
    public static final String RESOURCEPROVIDER_PROPERTY        = "property";
    public static final String RESOURCEPROVIDER_OUT             = "out";
    public static final String RESOURCEPROVIDER_SYSTEMPROP      = "systemprop";
    public static final String RESOURCEPROVIDER_SYSTEMENV       = "systemenv";

    public static final String RESOURCEPROVIDER_FILE            = "file";
    public static final String RESOURCEPROVIDER_FILE0           = "file0";
    public static final String RESOURCEPROVIDER_FILE2           = "file2";
    public static final String RESOURCEPROVIDER_FILE2A          = "file2a";
    public static final String RESOURCEPROVIDER_DIR             = "dir";
    public static final String RESOURCEPROVIDER_DIR0            = "dir0";
    public static final String RESOURCEPROVIDER_FILESTRING      = "file.string";
    public static final String RESOURCEPROVIDER_FILESTRINGARRAY = "file.stringarray";
    public static final String RESOURCEPROVIDER_FILEURL			= "file.url";
    
    public static final String RESOURCEPROVIDER_URL             = "url";
    public static final String RESOURCEPROVIDER_URLSTRING       = "url.string";
    public static final String RESOURCEPROVIDER_URLSTRINGARRAY  = "url.stringarray";
    
    public static final String RESOURCEPROVIDER_DATALIST        = "data.list";
    public static final String RESOURCEPROVIDER_DATASET         = "data.set";
    public static final String RESOURCEPROVIDER_DATAMAP         = "data.map";
    public static final String RESOURCEPROVIDER_DATAMAP0        = "data.map0";
    public static final String RESOURCEPROVIDER_DATAMAP_GET     = "data.map.get";
    public static final String RESOURCEPROVIDER_DATAMAP_KEYSET  = "data.map.keyset";
    public static final String RESOURCEPROVIDER_DATAMAP_WRAPPING  = "data.map.wrapping";
    public static final String RESOURCEPROVIDER_DATATREE        = "data.tree";
    public static final String RESOURCEPROVIDER_DATADOCUMENT    = "data.document";
    public static final String RESOURCEPROVIDER_LISTING         = "listing";
    
    public static final String RESOURCEPROVIDER_ENTITYUNIQUE    = "entity.unique";
    public static final String RESOURCEPROVIDER_ENTITYNEW       = "entity.new";
    public static final String RESOURCEPROVIDER_ENTITYPROVIDE   = "entity.provide";
    public static final String RESOURCEPROVIDER_ENTITYRETRIEVE  = "entity.retrieve";
    public static final String RESOURCEPROVIDER_ENTITYRETRIEVE2 = "entity.retrieve2";
    public static final String RESOURCEPROVIDER_ENTITYTRANSFORM = "entity.transform";
    public static final String RESOURCEPROVIDER_ENTITYGUI       = "entity.gui";
    
    public static final String RESOURCEPROVIDER_PROCESS_FILTER          = "process.filter";
    public static final String RESOURCEPROVIDER_PROCESS_GIVE            = "process.give";
    public static final String RESOURCEPROVIDER_PROCESS_GUI             = "process.gui";
    public static final String RESOURCEPROVIDER_PROCESS_PROVIDE         = "process.provide";
    public static final String RESOURCEPROVIDER_PROCESS_REGISTER        = "process.register";
    public static final String RESOURCEPROVIDER_PROCESS_RETRIEVE        = "process.retrieve";
    public static final String RESOURCEPROVIDER_PROCESS_TRANSFORM       = "process.transform";
    
    public static final String RESOURCEPROVIDER_COMBINE_TRANSFORM       = "combine.transform";
    public static final String RESOURCEPROVIDER_COMBINE_EXECUTE         = "combine.execute";
    public static final String RESOURCEPROVIDER_COMBINE_GIVE            = "combine.give";
    
    public static final String RESOURCEPROVIDER_WRAP_PROVIDE            = "wrap.provide";
    public static final String RESOURCEPROVIDER_WRAP_FILTER             = "wrap.filter";
    public static final String RESOURCEPROVIDER_WRAP_EXECUTE            = "wrap.execute";
    public static final String RESOURCEPROVIDER_WRAP_GUI                = "wrap.gui";
    
    public static final String INTERNAL_MAP_SERVERS             = "app.servermap";
    public static final String INTERNAL_MAP_ACTIONS             = "app.actionmap";
    public static final String INTERNAL_MAP_ACTIONINFOS         = "app.actioninfomap";
    public static final String INTERNAL_MAP_OBJECTENTITY        = "app.entityobjectmap";
    public static final String INTERNAL_MAP_DATEENTITY          = "app.entitydatemap";
    public static final String INTERNAL_MAP_USEDDATEENTITY      = "app.entityuseddatemap";
    public static final String INTERNAL_MAP_BUILDTIMEENTITY     = "app.entitybuildtimemap";
    public static final String INTERNAL_MAP_NUMBERENTITY        = "app.entitynumbermap";
    public static final String INTERNAL_MAP_DATASTORE_DATA      = "app.datastore.datamap";
    public static final String INTERNAL_MAP_DATASTORE_FILES     = "app.datastore.filemap";
    public static final String INTERNAL_MAP_DATASTORE_ACCESS    = "app.datastore.accessmap";
    public static final String INTERNAL_MAP_MAPPINGRECORD       = "app.mappingrecordmap";
    public static final String INTERNAL_MAP_STARTERRORS         = "app.starterrorsmap";
    
    public static final String INTERNAL_STRING_MAINGUI_ENTIY    = "app.maingui.entity";
    public static final String INTERNAL_STRING_USERNAME         = "app.username";
    public static final String INTERNAL_STRING_MANAGERID        = "app.managerid";
    public static final String INTERNAL_JFRAME_APPFRAME         = "app.gui.frame";
    public static final String INTERNAL_JMENUBAR_APPMENUBAR     = "app.gui.menubar";
    public static final String INTERNAL_OBJ_ICONPROVIDER        = "app.gui.icons";
    public static final String INTERNAL_OBJ_PRIVATEKEYSIGNER    = "app.security.privatekeysigner";
    public static final String INTERNAL_OBJ_PUBLICKEY           = "app.security.publickey";
    public static final String INTERNAL_OBJ_SOUNDS              = "app.sounds";
    public static final String INTERNAL_OBJ_SERVERS             = "app.servers";
    public static final String INTERNAL_OBJ_ACTIONHANDLER       = "app.actionhandler";
    public static final String INTERNAL_OBJ_LOGFILE             = "app.logfile";
    public static final String INTERNAL_SUPPORT_LING            = "app.supportling";
    public static final String INTERNAL_OBJ_LINGSTRING          = "app.lingstring";
    public static final String INTERNAL_SET_LINGSTRING_KEYS     = "app.lingstring.keys";
    public static final String INTERNAL_SUPPORT_DEBUGGER        = "app.supportdebugger";
    public static final String INTERNAL_EXECUTE_EXIT            = "app.executeexit";
    public static final String INTERNAL_ACTION_EXIT             = "app.actionexit";
    public static final String INTERNAL_OBJ_CONFIRMEXIT         = "app.confirmexit";
    public static final String INTERNAL_OBJ_CUSTOMIZEFRAME      = "app.customizeframe";
    public static final String INTERNAL_OBJ_MAINGUI             = "app.gui.maingui";
    public static final String INTERNAL_OBJ_ENTITY              = "app.entity";
    public static final String INTERNAL_OBJ_ENTITYLOADER        = "app.entity.loader";
    public static final String INTERNAL_OBJ_UNIQUEENTITY        = "app.entity.unique";
    public static final String INTERNAL_OBJ_NEWENTITY           = "app.entity.new";
    public static final String INTERNAL_OBJ_ENTITYRESOURCECALL  = "app.entity.resourcecall";
    public static final String INTERNAL_OBJ_ENTITYSERVICECALL   = "app.entity.servicecall";
    public static final String INTERNAL_OBJ_ENTITYINFO          = "app.infoentity";
    public static final String INTERNAL_OBJ_TIMER               = "app.timer";
    public static final String INTERNAL_OBJ_ERRORNUMBER         = "app.errornumber";
    public static final String INTERNAL_ICON_APPICON            = "app.icon";
    
    public static final String SUBSTITUTE_ACCESSFILE            = "accessfile";
    public static final String SUBSTITUTE_CUSTOMIZEDATA         = "customizedata";
    
    // prop keys
    public static final String PROPKEY_APPICON              = "app.icon";
    public static final String PROPKEY_APPSIZE              = "app.size";
    public static final String PROPKEY_APPTITLE             = "app.title";
    public static final String PROPKEY_APPVERSION           = "app.version";
    public static final String PROPKEY_APPCREATIONDATE      = "app.creationdate";
    public static final String PROPKEY_APPVISIBLEONSTART    = "app.visibleonstart";
    public static final String PROPKEY_APPSUPPORTEDLANGUAGES   = "app.supportedlanguages";
    
    public static final String PROPKEY_PRINTENTITYCREATIONS = "app.debug.printentitycreations";
    
    // pers keys
    public static final String PERSKEY_LANGUAGE             = "language";
    public static final String PERSKEY_LAF                  = "laf";
    
    // icon keys
    public static final String ICONKEY_DEFAULT              = "DEFAULT";

    public static final String FILENAME_ENTITY_CREATIONDATES            = "EntityDate.properties";
    public static final String FILENAME_ENTITY_CALLS                    = "EntityCall.properties";
    public static final String FILENAME_ENTITY_ACTIONS                  = "EntityActions.properties";
    public static final String FILENAME_LINGKEYS                        = "LingKeys.txt";
    public static final String FILENAME_ICONS_FILESYSTEM                = "Icons_FileSystem.properties";
    public static final String FILENAME_SECURITYCONTACTDIR              = "contacts";
    public static final String FILENAME_SECUREDENTITYLIST               = "SecuredEntityList.txt";
      
    public static final String LINGTAG_ACTIONNAME                       = "ACTION_NAME_";
    public static final String LINGTAG_ACTIONDESC                       = "ACTION_DESCRIPTION_";
    
    public static final String PATH_SECURITYDIR             = "path.securitydir";
    public static final String PATH_DEBUGDIR                = "path.debugdir";
    public static final String PATH_ENTITYCALLFILE          = "path.entitycall";
    
    public static final String INTERNAL_OBJ_DATASTORE           = "app.datastore";
    public static final String INTERNAL_OBJ_FILEPROVIDER        = "app.files";
    public static final String INTERNAL_MAP_PUBLICKEYS          = "app.security.publickeymap";
    
    
    public static final String LOCATION_ENTITYDATEMAP          = "location.entitydate";
    public static final String LOCATION_ENTITYUSEDDATEMAP      = "location.entityuseddate";
    public static final String LOCATION_ENTITYACTIONMAP        = "location.entityaction";
    public static final String LOCATION_ENTITYCALLMAP          = "location.entitycall";
    public static final String LOCATION_LINGKEYSSET            = "location.lingkeys";
    public static final String LOCATION_PERSISTENCE            = "location.persistence";
    
    
    
    
    
    
    
    
    
    public static EntityGenerator entityGenerator;
    public static ActionManager actionManager;
    public static DataManager dataManager;
    public static StartManager startManager;
    public static GuiManager guiManager;
    
    
    
    
    public static void init_2()
    {
        changePhase(2);
        m2("init_2()","INITIALIZE MANAGERS");
        entityGenerator = new EntityGenerator();
        m2("init_2()","entityGenerator created");
        actionManager = new ActionManager();
        m2("init_2()","actionManager created");
        startManager = new StartManager();
        m2("init_2()","startManager created");
        dataManager = new DataManager();
        m2("init_2()","dataManager created");
        guiManager = new GuiManager();
        m2("init_2()","guiManager created");
        
        
        changePhase(3);
        m2("init_2()","LOAD PROVIDERS");
        d2("init_2()",providerMap.size()+" providers already loaded");
        new Loader_providers();
        m2("init_2()",providerMap.size()+" providers have been loaded");
        
        
        changePhase(4);
        m2("init_2()","LOAD INTERNALS");
        d2("init_2()",internalMap.size()+" internals already loaded");
        new Loader_internals();
        m2("init_2()",internalMap.size()+" internals have been loaded");
        
        
        changePhase(5);
        m2("init_2()","LOAD ENTITIES");
        new Loader_entities();
        m2("init_2()",entityMap.size()+" entities have been loaded"); 
        if(entityMap.isEmpty()) w2("init_2()","NO ENTITY FOUND");
        
        
        changePhase(6);
        m2("init_2()","initialize action gui and log");
        actionManager.init();
        guiManager.init();
        initLogFile();
    }
    
    
    
    
    
    private static void initLogFile()
    {
        try
        {
            Provide p = (Provide) getInternal(INTERNAL_OBJ_LOGFILE);
            if(p==null)return;
            PrintStream log = (PrintStream) p.provide();
            if(log!=null) appOut.initPrintStream(log);
        }
        catch(Exception e)
        {e2("initLogFile()",e);}
    }
    
    
    
    
    
    public static void startApp()
    {
        changePhase(7);
        m2("startApp()", "START APPLICATION");
        
        // start entities
        startManager.start();
        
        // start graphical
        Graphic mainGraphic = (Graphic) getInternal(INTERNAL_OBJ_MAINGUI);
        guiManager.startGraphic(mainGraphic);
        
        
        m2("startApp()", "main gui: "+sourceName(mainGraphic));
        m2("startApp()", "started entities: "+startManager.number);
        if(!startManager.errors.isEmpty())
            m2("startApp()", " - failed: "+startManager.errors.size());
        m2("startApp()", "created instances: "+entityGenerator.number);
        m2("startApp()", "free jvm memory: "+Runtime.getRuntime().freeMemory());
        m2("startApp()", "start duration: "+fromStart());
        
        changePhase(8);
        m2("startApp()", "RUNTIME");
        start();
        m2("startApp()", "app is running... ");
    }
    
    
    
    
    
    
    
    public static void exitApp()
    {
        if(!confirmExit()) return;
        
        changePhase(9);
        m2("exitApp()", "EXIT APPLICATION");
        m2("exitApp()", "running duration: "+fromStart());
        exit();
    }
    
    
    private static boolean confirmExit()
    {
        try
        {
            Filter f = (Filter) getInternal(INTERNAL_OBJ_CONFIRMEXIT);
            if(f==null)return true;
            return f.filter(appObject);
        }
        catch(Exception e)
        {e2("confirmExit()",e);}
        return true;
    }
    
    
    
    
    
    public static Object anonymousCall(String id) throws Exception
    {
        Transform caller = (Transform)getInternal(INTERNAL_OBJ_ENTITYRESOURCECALL);
        return caller.transform(id);
    }
    
    
    
    
    
    
    
    //**********************************************
    // Data
    
    public static Object getData(String dataID) throws Exception
    {return dataManager.transform(dataID);}
    
    
    public static Map getDataMap(String dataLocation)
    {
        try{return (Map)dataManager.transform(RESOURCEPROVIDER_DATAMAP+"#"+dataLocation);}
        catch(Exception e){e2("getDataMap(String)",e);}
        return new SupportMap("DEFAULT_"+dataLocation);
    }
    
    public static Set getDataSet(String dataLocation)
    {
        try{return (Set)dataManager.transform(RESOURCEPROVIDER_DATASET+"#"+dataLocation);}
        catch(Exception e){e2("getDataSet(String)",e);}
        return new SupportSet("DEFAULT_"+dataLocation);
    }
    
    
    
    public static Map getDataMap0(String id)
    {
        String dataID = getProperty(id,id);
        return getDataMap(dataID);
    }
    
    public static Set getDataSet0(String id)
    {
        String dataID = getProperty(id,id);
        return getDataSet(dataID);
    }
    
    
    
    
    
    
    
    
    
    
    
    //*******************************************************
    // Persistence
    
    public static Map pers()
    {return getDataMap0(LOCATION_PERSISTENCE);}
    
    public static boolean hasPersistence(String name)
    {return pers().containsKey(name);}
    
    public static String getPersistence(String name)
    {return (String)pers().get(name);}
    
    public static boolean booleanPersistence(String name)
    {return getPersistence(name).toLowerCase().equals("true");}
    
    public static void setPersistence(String name, String value)
    {pers().put(name,value);}
    
    
    
    
    
    //*******************************************************
    // Language
    
    public static String language()
    {
        if(hasPersistence(PERSKEY_LANGUAGE))
            return getPersistence(PERSKEY_LANGUAGE);
        return initialLanguage();
    }
    
    
    private static String initialLanguage()
    {
    	if(hasProperty(PROPKEY_APPSUPPORTEDLANGUAGES))
        {
        	String supported = getProperty(PROPKEY_APPSUPPORTEDLANGUAGES);
        	String userLanguage = userLanguage();
        	if(supported.contains(userLanguage)) return userLanguage;
        	
        	if(hasProperty(PERSKEY_LANGUAGE))
                return getProperty(PERSKEY_LANGUAGE);
        	return supported.split(";")[0];
        }
        if(hasProperty(PERSKEY_LANGUAGE))
            return getProperty(PERSKEY_LANGUAGE);
        return userLanguage();
    }
    
    
    private static String userLanguage()
    {return System.getProperty("user.language");}
    
    
    
    
    public static void setLanguage(String lang)
    {
        setPersistence(PERSKEY_LANGUAGE,lang);
    }
    
    public static String ling(String key)
    {
        StringProvider sp = (StringProvider)getInternal(INTERNAL_OBJ_LINGSTRING);
        if(sp==null) return key;
        return sp.getString(key);
    }
    
    public static void registerToLing(ActionListener listener)
    {
        Support lingSupport = (Support)getInternal(INTERNAL_SUPPORT_LING);
        if(lingSupport!=null) lingSupport.addActionListener(listener);
    }
    
    
    
    
    
    
    
    
    //*******************************************************
    // Look and Feel
    
    public static String lookAndFeel()
    {
        if(hasPersistence(PERSKEY_LAF))
            return getPersistence(PERSKEY_LAF);
        if(hasProperty(PERSKEY_LAF))
            return getProperty(PERSKEY_LAF);
        return null;
    }
    
    
    
    
    
    
    
    //*******************************************************
    // File
    
    public static File poolFile(String source)
    {
        String[] n = source.split("@",2);
        
        File poolDir = getFile(PATH_POOLDIR);
        File dataDir = new File(poolDir,n[0]);
        dataDir.mkdirs();
        
        return new File(dataDir,n[1]+".txt");
    }
    
    
    
    public static File poolDir(String source)
    {
        String[] n = source.split("@",2);
        
        File poolDir = getFile(PATH_POOLDIR);
        File dataDir = new File(poolDir,n[0]);
        dataDir.mkdirs();
        
        return new File(dataDir,n[1]);
    }
    
    
    
    
    
    //********************************************
    // printing
    
    private static void m2(String id, String message)
    {printMessage(System2.class,id,message);}
    
    private static void w2(String id, String message)
    {printWarning(System2.class,id,message);}
    
    private static void e2(String id, Exception e)
    {handleError(System2.class,id,e);}
    
    private static void d2(String id, String message)
    {printDebug(System2.class,id,message);}
}
